from PyQt5 import QtCore, QtWidgets, QtGui
from PyQt5.QtCore import Qt, QMimeData
from PyQt5.QtWidgets import QTreeWidgetItem, QFrame, QFileDialog, QMessageBox
from PyQt5.QtGui import QDrag, QFont

from decode import decode_data, get_rows

import List

class MasterList(List.List):
    def __init__(self, name, parent=None):
        super().__init__(name, parent)
        self.setDefaultDropAction(QtCore.Qt.CopyAction)
        self.data_items = []

    def dragLeaveEvent(self, event):
        #print("MasterList dragLeaveEvent")
        pass

    def dragEnterEvent(self, event):
        #print(f"MasterList dragEnterEvent ({event.mimeData()})")
        md = event.mimeData()
        #print(f"md = {md}, text = '{md.text()}'")
        event.mimeData().setText(self.objectName())
        bytearray = event.mimeData().data('application/x-qabstractitemmodeldatalist')
        self.data_items = get_rows(bytearray)
        #print(f"data_items = {self.data_items}")
        #for i in self.data_items:
            #self.item(i).setFlags(Qt.NoItemFlags)
        #super().dragEnterEvent(event)
        #event.accept() # Enables the dragLeaveEvent method for some stupid reason

    def dropEvent(self, event):
        #print("MasterList dropEvent")
        super().dropEvent(event)

