
BEGIN {
    FS = ","
    first_tm_obt = 0
    last_tm_obt  = 0
}

END {
    printf "%s,%s\n", first_tm_obt, last_tm_obt
}

function save_obt(obt) {
    if (first_tm_obt == 0) {
	first_tm_obt = obt
    }
    else {
	last_tm_obt = obt
    }
}

# Remove the data templates
/^TM,trx/     { next }
/^TMPAR,name/ { next }
/^EV,logTime/ { next }

/^TM,/        { save_obt($12); next }
              { next }